PRO data_extractor

;UAID FILE PATH
uaid_path='/npp/ndata1/collects/u3101k_u3102k/'
extractor_path='/home/jmcintire/data_extractor/Data_Extractor_Ver_B/'
output_path='/npp/ndata1/dump/jmcintire/RC01_FU1'
output_path='/home/jmcintire'

;UAIDS TO BE PROCESSED
uaid_num=['3101362']

;BAND TO BE PROCESSED
band_val=[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22]
;band_names=['I1','I2','I3','I4','I5','M1','M2','M3','M4','M5','M6','M7','M8','M9','M10','M11','M12','M13','M14','M15','M16','M16A','M16B']
;band_id=['6','7','14','13','19','2','3','5','4','9','10','8','17','18','15','16','12','11','23','22','24','20','21']
band_names=['I4','I5','M12','M13','M14','M15','M16','M16A','M16B']
band_id=['13','19','12','11','23','22','24','20','21']
band_num='1'
band_names=['M13']
band_id=['11']
band_num='1'

;bb_name='_TMC' or '_BCS'
bb_name=''

;SECTOR TO BE EXTRACTED
sector_name=['/EVDataView evBoth','/SVDataView svBoth','/OBCDataView OBCBoth','/SDDataView sdBoth']

;SAMPLE RANGE
ib_nsample=[3300,-1,-1,-1]
ib_sample_start=[3700,-1,-1,-1]

mb_nsample=[1650,-1,-1,-1]
mb_sample_start=[1850,-1,-1,-1]

samp_name=['EVNumSamplesReq','SVNumSamplesReq','OBCNumSamplesReq','SolDiffNumSamplesReq']
samp_name2=['evSpecSample','svSpecSample','obcSpecSample','sdSpecSample']

sector_type=['EV','SV','OBC','SD']
sector_name=['earth_view','svs','obc','solar_diffuser']
gain_setting=['evBoth','svBoth','obcBoth','sdBoth']

FOR uaid=0, N_ELEMENTS(uaid_num)-1 DO BEGIN

    ; picking collects.
    CASE uaid_num[uaid] OF
        '3101362': BEGIN
            colll=['002']
        END
    ENDCASE	
	
    cll_num=N_ELEMENTS(colll)

    band_val=INDGEN(N_ELEMENTS(band_names))

    FOR collect=0, cll_num-1 DO BEGIN
        FOR i=0, MAX(band_val) DO BEGIN
            band=band_val[i]
            FOR sector=0, 2 DO BEGIN
                ofile_name='U'+uaid_num[uaid]+'_'+sector_type[sector]+'_C'+colll[collect]+'_'+band_names[band]+bb_name+'.dmp'
                print, ofile_name
                IF band_id[i] EQ '6' OR band_id[i] EQ '7' OR band_id[i] EQ '14' OR band_id[i] EQ '13' OR band_id[i] EQ '19' THEN BEGIN ; I Bands
                    nsamp=ib_nsample[sector]
                    min_samp=ib_sample_start[sector]
                ENDIF ELSE BEGIN ; M-Bands
                    nsamp=mb_nsample[sector]
                    min_samp=mb_sample_start[sector]
                ENDELSE
                OPENW,LUN,extractor_path+'input.log',/GET_LUN
                PRINTF,LUN,'collect_file '+uaid_path+'u'+uaid_num[uaid]+'/U'+uaid_num[uaid]+'_C'+colll[collect]+'.wbd'
                PRINTF,LUN,'output_file '+output_path+'/'+ofile_name
                PRINTF,LUN,'NumScansReq -1'
                PRINTF,LUN,'HAM_A TRUE'
                PRINTF,LUN,'HAM_B TRUE'
                PRINTF,LUN,'TBAR 0'
                PRINTF,LUN,'QUICK 0'
                PRINTF,LUN,'NumBandsReq '+band_num 
                PRINTF,LUN,'specBandReq '+band_id[band] ;#Band number from Bandinfo.txt 
                PRINTF,LUN,'NumDataViewsReq 1' ;#Number of views requested
                PRINTF,LUN,'specView '+sector_name[sector] ;#Specific view requested
                PRINTF,LUN,'gain '+gain_setting[sector] ;#Gain State requested
                IF nsamp NE -1 THEN BEGIN
                    PRINTF,LUN,samp_name[sector]+' ',nsamp ;#Number of samples requested
                    FOR smp=min_samp,min_samp+nsamp-1 DO BEGIN
                        PRINTF,LUN,samp_name2[sector]+' ',smp,FORMAT='(a13,i6)' ;#Specific sample requested
                    ENDFOR
                ENDIF ELSE PRINTF,LUN,samp_name[sector]+' All'
                PRINTF,LUN,'NumDetectorsReq 32' ;#Number detectors requested
                PRINTF,LUN,'specDetector 01' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 02' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 03' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 04' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 05' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 06' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 07' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 08' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 09' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 10' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 11' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 12' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 13' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 14' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 15' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 16' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 17' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 18' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 19' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 20' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 21' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 22' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 23' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 24' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 25' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 26' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 27' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 28' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 29' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 30' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 31' ;#Specific Detector requested
                PRINTF,LUN,'specDetector 32' ;#Specific Detector requested
                PRINTF,LUN,'GainBits FALSE' ;#Extract gainbits TRUE/FALSE       
                
                FREE_LUN,LUN
                SPAWN,extractor_path+'extractorPH C -t '+extractor_path+'input.log -l '+extractor_path+'input.log'
                print,extractor_path+'extractorPH C -t '+extractor_path+'input.log -l '+extractor_path+'input.log'
                print,ofile_name
            ENDFOR
        ENDFOR
    ENDFOR
ENDFOR

END
